;******************************************************************************
  use32
  org	 0x0
  db	 'MENUET01'   ; 8 byte id
  dd	 0x01	      ; header version
  dd	 START	      ; program start
  dd	 I_END	      ; program image size
  dd	 I_END	    ; memory
  dd	 I_END	    ; stack
  dd	 param_area ,0x0   ; param,icon

;******************************************************************************

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   Create by Pavlushin Evgeni     /-----------\        waptap[at]mail.ru
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~             ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

include 'ascl.inc'
include 'ascgl.inc'
include 'getimgp.inc'

START:				; start of execution
; mouse interput on
   mov eax,40
   mov ebx,0100111b
   int 0x40

; unpuck skin
   bmptoimg bmpfile,imgstruc
; unpuck fragments
   mov eax,0  ;x
   mov ebx,0  ;y
   mov esi,16 ;xs
   mov edi,16 ;ys
   mov ecx,imgstruc ;source
   mov edx,ubup     ;dest
   call getimgproc
   add eax,16 ;x
   mov edx,ubdn
   call getimgproc
   add eax,16 ;x
   mov edx,dbup
   call getimgproc
   add eax,16 ;x
   mov edx,dbdn
   call getimgproc
   mov eax,80 ;x
   mov ebx,0  ;y
   mov esi,16 ;xs
   mov edi,2 ;ys
   mov edx,bglup     ;dest
   call getimgproc
   add ebx,2  ;y
   mov edx,bgldn     ;dest
   call getimgproc
   mov eax,80-16 ;x
   mov ebx,0  ;y
   mov esi,16 ;xs
   mov edi,2 ;ys
   mov edx,mm1up     ;dest
   call getimgproc
   add ebx,2  ;y
   mov edx,mm2up     ;dest
   call getimgproc
   add ebx,2  ;y
   mov edx,mm3up     ;dest
   call getimgproc
   mov eax,80-16 ;x
   mov ebx,0  ;y
   mov esi,16 ;xs
   mov edi,2 ;ys
   mov edx,mm1dn     ;dest
   call getimgproc
   add ebx,2  ;y
   mov edx,mm2dn     ;dest
   call getimgproc
   add ebx,2  ;y
   mov edx,mm3dn     ;dest
   call getimgproc
; ub dn fade
   mov eax,96  ;x
   mov ebx,0  ;y
   mov esi,16 ;xs
   mov edi,16 ;ys
   mov ecx,imgstruc ;source
   mov edx,ubfade     ;dest
   call getimgproc
   add eax,16 ;x
   mov edx,dbfade
   call getimgproc
   mov eax,80 ;x
   mov ebx,4  ;y
   mov esi,16 ;xs
   mov edi,2 ;ys
   mov edx,bglfade     ;dest
   call getimgproc

; read file
   mov ebx,fileinfo
   mov eax,58
   int 0x40
   cmp eax,5
   je okr
   cmp eax,0
   je okr
   close
okr:
   mov edi,ebx
; format text
   mov esi,-1
   mov ecx,0
   mov edx,0
endstr:
   cmp edx,100000
   jae endfor
   inc esi
   mov ebp,0
nextchr:
   cmp ecx,edi
   jae endfor
   mov al,[itext+ecx]
   cmp al,0ah
   je  nextstr
   mov [text+edx],al
   inc ecx
   inc edx
   inc ebp
   cmp ebp,80
   jb  nextchr
   dec ecx
movetoend:
   cmp ecx,edi
   jae endfor
   inc ecx
   mov al,[itext+ecx]
   cmp al,0ah
   jne	movetoend
   inc ecx
   jmp endstr
nextstr:
   mov [text+edx],byte ' '
   inc edx
   inc ebp
   cmp ebp,80
   jb nextstr
   inc ecx
   jmp endstr
endfor:
   mov dword [vscroll+44],esi

   call draw_window

;Main loop wait for event with 10msec
still:
   mov eax,23
   mov ebx,10
   int 0x40
   cmp eax,1
   je red
   cmp eax,2
   je key
   cmp eax,3
   je button
   cmp eax,6
   je mouse

   call getmousestat
   mov ebp,vscroll
   call vscrollmouse
   mov ebp,vscroll
   call drawvscroll
   jnc	noupd
   call showtext
noupd:

   jmp	still

showtext:
   mov ebx,10*65536+80*6
   mov ecx,40*65536+200
   mov edx,0x00ffffff
   mov eax,13
   int 0x40

   mov edx,[vscroll+48]
   imul edx,80
   add edx,text

   mov ebp,20
   mov ebx,10*65536+40
tloo:
   mov ecx,0x00000000
   mov esi,80
   mov eax,4
   int 0x40
   add ebx,10
   add edx,80
   dec ebp
   jnz tloo
   ret

simgoff: dd 0
; ebp - pointer to scroll structure
drawvscroll:
   cmp [ebp+60],dword 1 ;needed redraw?
   je  nedred
   clc
   ret ;redraw not needed!
;simgoff dd 0
nedred:
redrawvscroll:

   call fadeed_status

; draw scroll bg line
   cmp [fadeed],dword 1
   jne nof4
   mov ebx,[ebp+152]   ;fade pic
   mov edx,[ebp+164]   ;fade col
   bt dword [ebp+84],10
   jc bglpic
   jmp itnp1
nof4:
   cmp [ebp+56],dword 6
   je  itp1
   mov edx,[ebp+16] ;bgl color
   mov ebx,[ebp+104] ;off to image
   bt dword [ebp+84],4
   jc bglpic
   jmp itnp1
itp1:
   mov edx,[ebp+68] ;bgl pressed line color
   mov ebx,[ebp+108] ;off to image
   bt dword [ebp+84],5
   jc bglpic
itnp1:

   mov ebx,[ebp] ;x
   shl ebx,16
   add ebx,[ebp+8] ;xs
   mov ecx,[ebp+4] ;y
   shl ecx,16
   add ecx,[ebp+12] ;ys
   mov eax,13
   int 0x40
   jmp bglcol
bglpic:
   mov eax,[ebp+12] ;ys
   cdq
   idiv dword [ebp+112] ;img size
   mov edi,eax
   mov ecx,[ebp+8] ;xs
   shl ecx,16
   add ecx,[ebp+112] ;img size
   mov edx,[ebp] ;x
   shl edx,16
   add edx,[ebp+4] ;y
bgldl:
   mov eax,7
   int 0x40
   add edx,[ebp+112] ;img size
   dec edi
   jnz bgldl
bglcol:

; draw scroll up button
   cmp [fadeed],dword 1
   jne nof1
   mov ebx,[ebp+144]   ;fade pic
   mov edx,[ebp+156]   ;fade col
   bt dword [ebp+84],8
   jc ubpic
   jmp itnp2
nof1:
   cmp [ebp+56],dword 3
   je  itp2
   mov edx,[ebp+24] ;up but color
   mov ebx,[ebp+88] ;off to image
   bt dword [ebp+84],0
   jc ubpic
   jmp itnp2
itp2:
   mov edx,[ebp+72] ;up but pressed line color
   mov ebx,[ebp+92] ;off to image
   bt dword [ebp+84],1
   jc ubpic
itnp2:

   mov ebx,[ebp] ;x
   shl ebx,16
   add ebx,[ebp+8] ;xs
   mov ecx,[ebp+4] ;y
   shl ecx,16
   add ecx,[ebp+20] ;up button size!
   mov eax,13
   int 0x40
   jmp ubcol
ubpic:
   mov edx,[ebp] ;x
   shl edx,16
   add edx,[ebp+4] ;y
   mov ecx,[ebp+8] ;xs
   shl ecx,16
   add ecx,[ebp+20] ;ubs
   mov eax,7
   int 0x40
ubcol:

; draw scroll down button
   cmp [fadeed],dword 1
   jne nof2
   mov ebx,[ebp+148]   ;fade pic
   mov edx,[ebp+160]   ;fade col
   bt dword [ebp+84],9
   jc dbpic
   jmp itnp3
nof2:
   cmp [ebp+56],dword 4
   je  itp3
   mov edx,[ebp+32] ;down but color
   mov ebx,[ebp+96] ;off to image
   bt dword [ebp+84],2
   jc dbpic
   jmp itnp3
itp3:
   mov edx,[ebp+76] ;down but pressed line color
   mov ebx,[ebp+100] ;off to image
   bt dword [ebp+84],3
   jc dbpic
itnp3:

   mov ebx,[ebp] ;x
   shl ebx,16
   add ebx,[ebp+8] ;xs
   mov ecx,[ebp+4] ;y
   add ecx,[ebp+12] ;ys
   sub ecx,[ebp+28] ;dbs!
   shl ecx,16
   add ecx,[ebp+28] ;down button size!
   mov eax,13
   int 0x40
   jmp dbcol
dbpic:
   mov edx,[ebp] ;x
   shl edx,16
   add edx,[ebp+4] ;y
   add edx,[ebp+12] ;ys
   sub edx,[ebp+28] ;dbs!
   mov ecx,[ebp+8] ;xs
   shl ecx,16
   add ecx,[ebp+28] ;dbs!
   mov eax,7
   int 0x40
dbcol:

; draw scroll movment box ebp+36-color
   cmp [fadeed],dword 1
   je  mmcol

   cmp [ebp+56],dword 5
   je  itp4
   mov edx,[ebp+36] ;down but color
   mov [simgoff],ebp ;off to image
   add [simgoff],dword 116
   bt dword [ebp+84],6
   jc mmpic
   jmp itnp4
itp4:
   mov edx,[ebp+80] ;down but pressed line color
   mov [simgoff],ebp ;off to image
   add [simgoff],dword 132
   bt dword [ebp+84],7
   jc mmpic
itnp4:

   call getmovmentbox
; draw movment box
   mov ebx,[ebp] ;x
   shl ebx,16
   add ebx,[ebp+8] ;xs
   mov ecx,esi
   add ecx,[ebp+4] ;y
   add ecx,[ebp+20] ;up button size!
   shl ecx,16
   add ecx,edi	;y size
   mov eax,13
   int 0x40
   jmp mmcol
mmpic:

   mov eax,[simgoff]
   add eax,4
   mov ebx,[eax]  ;mm2
;   mov ebx,[ebp+116+4]
   call getmovmentbox
   mov eax,edi ;ysize
   cdq
   idiv dword [ebp+128] ;img size
   mov edi,eax
   mov ecx,[ebp+8] ;xs
   shl ecx,16
   add ecx,[ebp+128] ;img size
   mov edx,[ebp] ;x
   shl edx,16
   add edx,esi ;y
   add edx,[ebp+4] ;y
   add edx,[ebp+20] ;ubs
mm2dl:
   mov eax,7
   int 0x40
   add edx,[ebp+128] ;img size
   dec edi
   jnz mm2dl

   mov eax,[simgoff]
   mov ebx,[eax]  ;mm1
;   mov ebx,[ebp+116]  ;mm1
   mov ecx,[ebp+8] ;xs
   shl ecx,16
   add ecx,[ebp+128] ;img size
   mov edx,[ebp] ;x
   shl edx,16
   add edx,esi ;y
   add edx,[ebp+4] ;y
   add edx,[ebp+20] ;ubs
   mov eax,7
   int 0x40

   call getmovmentbox
   mov eax,[simgoff]
   add eax,8
   mov ebx,[eax]  ;mm3
;   mov ebx,[ebp+116+8]  ;mm3
   mov ecx,[ebp+8] ;xs
   shl ecx,16
   add ecx,[ebp+128] ;img size
   mov edx,[ebp] ;x
   shl edx,16
   add dx,[ebp+4] ;y
   add edx,[ebp+20] ;ubs
   add edx,esi ;y mm size
   add edx,edi ;y mm size
   sub edx,[ebp+128] ;img size
   mov eax,7
   int 0x40
mmcol:

   mov [ebp+60], dword 0 ;redraw complite!
   stc
   ret

fadeed: dd 0   ; its faded?
; save eax!
fadeed_status:
   push eax
   mov eax,dword [ebp+44]
   sub eax,dword [ebp+40]
   cmp eax,[ebp+52]
   jb  it_fded	 ;jb! not jbe
   mov [fadeed],dword 0
   jmp no_fded
it_fded:
   mov [fadeed],dword 1
no_fded:
   pop eax
   ret

; input : ebp - pinter to scroll structure
; output: esi - y pos in front of y pos scroll
;         edi - ysize of movment box
;         edx - special parametr for setmovmentbox
vstemp dd 0

getmovmentbox:
   finit
; calc scrl size
   mov edi,[ebp+12] ;ys
   sub edi,[ebp+20] ;ubs
   sub edi,[ebp+28] ;dbs
; range size
   mov esi,[ebp+44] ;maxr
   sub esi,[ebp+40] ;minr
   mov [vstemp],edi
   fild dword [vstemp]
   mov [vstemp],esi
   fidiv dword [vstemp]
   fld st0
   fimul dword [ebp+48] ;pos
   fistp dword [vstemp]
   mov esi,[vstemp]
   fimul dword [ebp+52] ;size of range
   fistp dword [vstemp]
   mov edi,[vstemp]

   mov edx,0   ;!!!!
   cmp edi,[ebp+168]  ;minimal size if before recalc
   jnl oksz
   mov edx,[ebp+168]
   sub edx,edi
; calc scrl size
   mov edi,[ebp+12] ;ys
   sub edi,edx
   sub edi,[ebp+20] ;ubs
   sub edi,[ebp+28] ;dbs
; range size
   mov esi,[ebp+44] ;maxr
   sub esi,[ebp+40] ;minr
   mov [vstemp],edi
   fild dword [vstemp]
   mov [vstemp],esi
   fidiv dword [vstemp]
   fimul dword [ebp+48] ;pos
   fistp dword [vstemp]
   mov esi,[vstemp]
   mov edi,[ebp+168]  ;size of mmbox
oksz:
   ret

; input : ebp - pointer to scroll structure
;         ebx - mouse ypos
; output: esi - pos
; function not complite
setmovmentbox:
   finit
; calc scrl size

   push ebx
   call getmovmentbox	;wanted get offset
   pop ebx

   mov edi,[ebp+12] ;ys
   sub edi,[ebp+20] ;ubs
   sub edi,[ebp+28] ;dbs
   sub edi,edx
; range size
   mov esi,[ebp+44] ;maxr
   sub esi,[ebp+40] ;minr
   mov [vstemp],edi
   fild dword [vstemp]
   mov [vstemp],esi
   fidiv dword [vstemp]
   fstp dword [vstemp]
; 1/elem size = elem in pixel
   fld1
   fdiv dword [vstemp]
   mov esi,ebx
   sub esi,[ebp+4] ;y
   sub esi,[ebp+20] ;dbs
   mov [vstemp],esi
   fimul dword [vstemp]
   fistp dword [vstemp]
   mov esi,[vstemp]
   ret


; ebp - offset to structure
; eax - x
; ebx - y
; ecx - buttons
vscrollmouse:
   call fadeed_status
   cmp [fadeed],dword 1
   jne nof
   ret
nof:

   cmp [ebp+60],dword 1
   je wredraw
   mov [ebp+60],dword 0
wredraw:

   cmp [ebp+56],dword 2
   je  noll
   cmp [ebp+56],dword 1
   je  noll
   cmp [ebp+56],dword 0
   je  noll
   mov [ebp+60],dword 1 ; when 1 loop after focus lost
noll:

   cmp ecx,0
   jne nolostfoc
   mov [ebp+56],dword 0 ;if buttons up then lost focus
nolostfoc:
   cmp [ebp+56],dword 3 ;focus on up but
   je  testvs
   cmp [ebp+56],dword 4 ;focus on dn but
   je  testvs
   cmp [ebp+56],dword 5 ;focus on mm but
   je  testvs
   cmp [ebp+56],dword 6 ;focus on sbl but
   je  testvs

   mov edx,[ebp]    ;x
   cmp eax,edx
   jb nohit
   add edx,[ebp+8]  ;xs
   cmp eax,edx
   ja nohit
   mov edx,[ebp+4]  ;y
   cmp ebx,edx
   jb nohit
   add edx,[ebp+12] ;ys
   cmp ebx,edx
   ja nohit

; if hit
   cmp [ebp+56],dword 0
   je minput
; else mouse moved on scroll
   cmp ecx,0
   jne no_upbuttons
   mov [ebp+56],dword 2  ;mstat=2 mouse in scroll and buttons up!
no_upbuttons:
   cmp [ebp+56],dword 1  ;if buttons pressed at start then quit
   je  endtest

; Test mouse!
testvs:
; hit to up button?
   cmp [ebp+56],dword 3
   je iup
   cmp [ebp+56],dword 2
   je iup
   jmp nup
iup:
   mov edx,[ebp]    ;x
   cmp eax,edx
   jb nohitub
   add edx,[ebp+8]  ;xs
   cmp eax,edx
   ja nohitub
   mov edx,[ebp+4]  ;y
   cmp ebx,edx
   jb nohitub
   add edx,[ebp+20] ;up button size
   cmp ebx,edx
   ja nohitub
; hit to up button
   cmp ecx,1 ;left pressed?
   jne nohitub
   push dword [ebp+48] ;nowpos
   call decvscrollpos
   pop eax
   cmp eax,[ebp+40] ;minr
   je  nor1
   mov [ebp+60],dword 1  ;need redraw
   jmp yr1
nor1:
   mov [ebp+60],dword 0  ;no need redraw
yr1:
   mov [ebp+56],dword 3  ;foconup
   jmp endtest
nohitub:
   mov [ebp+60],dword 0  ;no need redraw
   cmp [ebp+56],dword 3  ;only up!
   jne nup
   jmp endtest
nup:

; hit to dwown button?
   cmp [ebp+56],dword 4
   je idn
   cmp [ebp+56],dword 2
   je idn
   jmp ndn
idn:


   mov edx,[ebp]    ;x
   cmp eax,edx
   jb nohitdb
   add edx,[ebp+8]  ;xs
   cmp eax,edx
   ja nohitdb
   mov edx,[ebp+4]  ;y
   add edx,[ebp+12] ;ys
   sub edx,[ebp+28] ;dbs
   cmp ebx,edx
   jb nohitdb
   add edx,[ebp+28] ;dbs
   cmp ebx,edx
   ja nohitdb
; hit to up button
   cmp ecx,1 ;left pressed?
   jne nohitdb
   push dword [ebp+48] ; nowpos
   call incvscrollpos
   pop eax
   add eax,[ebp+52] ;range size
   cmp eax,[ebp+44] ;maxr
   je  nor2
   mov [ebp+60],dword 1  ;need redraw
   jmp yr2
nor2:
   mov [ebp+60],dword 0  ;no need redraw
yr2:
   mov [ebp+56],dword 4  ;focondn
   jmp endtest
nohitdb:
   mov [ebp+60],dword 0  ;no need redraw
   cmp [ebp+56],dword 4  ;only dn!
   jne ndn
   jmp endtest
ndn:

; hit to movmentbox?
   cmp [ebp+56],dword 5
   je imb
   cmp [ebp+56],dword 2
   je imb
   jmp nmb
imb:
   cmp [ebp+56],dword 5 ;lock mm
   je mmallock	 ;if already lock

   call getmovmentbox

   mov edx,[ebp]    ;x
   cmp eax,edx
   jb nohitmb
   add edx,[ebp+8]  ;xs
   cmp eax,edx
   ja nohitmb
   add esi,[ebp+4] ;y
   add esi,[ebp+20] ;ubs
   mov edx,esi
   cmp ebx,edx
   jb nohitmb
   add edx,edi
   cmp ebx,edx	   ;y size
   ja nohitmb

   call getmovmentbox
   add esi,[ebp+4]
   add esi,[ebp+20]

   mov edx,ebx
   sub edx,esi
   mov [ebp+64],edx

mmallock:

   sub ebx,[ebp+64] ;mmy
   call setmovmentbox
   call controlscrollpos

   cmp esi,[ebp+48]
   je nor
   mov [ebp+48],esi
   mov [ebp+60],dword 1  ;need redraw
   jmp edr
nor:
   mov [ebp+60],dword 0  ;dont need redraw
edr:
   mov [ebp+56],dword 5  ;foconmm
   jmp endtest
;noprmb:
nohitmb:
   cmp [ebp+56],dword 5  ;only mm!
   jne nmb
   jmp endtest
nmb:


; hit to sbl button? at last when z-pos of
; this button is max far
   cmp [ebp+56],dword 6
   je isbl
   cmp [ebp+56],dword 2
   je isbl
   jmp nsbl
isbl:
   mov edx,[ebp]    ;x
   cmp eax,edx
   jb nohitsbl
   add edx,[ebp+8]  ;xs
   cmp eax,edx
   ja nohitsbl
   mov edx,[ebp+4]  ;y
   add edx,[ebp+20] ;ubs
   cmp ebx,edx
   jb nohitsbl
   add edx,[ebp+12] ;ys
   sub edx,[ebp+20] ;ubs
   sub edx,[ebp+28] ;dbs
   cmp ebx,edx
   ja nohitsbl
; hit to sbl button
   cmp ecx,1 ;left pressed?
   jne nohitsbl

   call getmovmentbox
   add esi,[ebp+4]
   add esi,[ebp+20]
   cmp ebx,esi
   jae	vspgdn
vspgup:
   call vscrollpgup
   jmp vsep
vspgdn:
   add esi,edi
   cmp ebx,esi
   jbe lofoc	;scroll is stoped
   call vscrollpgdn
   jmp vsep
lofoc:
   mov [ebp+60],dword 1  ;need redraw
   mov [ebp+56],dword 1  ;lofoc wait buttons up
   jmp endtest
vsep:

   mov [ebp+60],dword 1  ;need redraw
   mov [ebp+56],dword 6  ;foconup
   jmp endtest
nohitsbl:
   cmp [ebp+56],dword 6  ;only up!
   jne nsbl
   jmp endtest
nsbl:

   jmp endtest
; mouse input to scroll
minput:
   cmp ecx,0
   je  conok
; mouse input to control with pressed buttons!!!
   mov [ebp+56],dword 1  ;mstat=1 mouse in scroll but buttons presssed!
   jmp endtest
conok:
   mov [ebp+56],dword 2  ;mstat=2 mouse in scroll and buttons up!
   jmp endtest
nohit:
   mov [ebp+56],dword 0  ;mstat=0 mouse not in scroll

endtest:

;   pushad
;   mov eax,[ebp+40]
;   mov [temp],eax
;   drawfbox 50,60,50,10,cl_White
;   outcount [temp],50,60,cl_Black,5*65536
;   popad
; Debug info!
;   mov eax,[ebp+56]
;   mov [temp],eax
;   drawfbox 50,50,50,10,cl_White
;   outcount [temp],50,50,cl_Black,5*65536

   ret

decvscrollpos:
   dec dword [ebp+48]
   mov edx,[ebp+48]
   cmp edx,[ebp+40]
   jnl decinr
   inc dword [ebp+48]
decinr:
   ret

incvscrollpos:
   inc dword [ebp+48]
   mov edx,[ebp+44]  ;maxr
   sub edx,[ebp+52]  ;sizeofr
   cmp [ebp+48],edx
   jng incinr
   dec dword [ebp+48]
incinr:
   ret

vscrollpgup:
   mov esi,[ebp+48]
   sub esi,[ebp+52]
   call controlscrollpos
   mov [ebp+48],esi
   ret

vscrollpgdn:
   mov esi,[ebp+48]
   add esi,[ebp+52]
   call controlscrollpos
   mov [ebp+48],esi
   ret

; input eax
controlscrollpos:
   cmp esi,[ebp+40] ;minr
   jnl noxl
   mov esi,[ebp+40]
noxl:
   mov edx,[ebp+44]
   sub edx,[ebp+52]
   cmp esi,edx ;maxr-sor
   jng noxg
   mov esi,[ebp+44]
   sub esi,[ebp+52] ;size of range!
noxg:
   ret

mouse:

   call getmousestat
   mov ebp,vscroll
   call vscrollmouse
   mov ebp,vscroll
   call drawvscroll
   jnc nodr
   call showtext
nodr:
   jmp still

getmousestat:
; at first buttons
; get mouse buttons to ecx
   mov eax,37
   mov ebx,2
   int 0x40
   mov ecx,eax
; second position
; get mouse pos eax-x , ebx-y
   mov eax,37
   mov ebx,1	;in front of window
   int 0x40
   mov ebx,eax
   shr eax,16	   ;x
   and ebx,0xffff  ;y
   ret

red:
   call draw_window
   jmp still

key:			      ; key
   mov eax,2
   int 0x40		      ; read (eax=2)
   shr eax,8

   jmp	still		       ; not testing

button: 		      ; button
   mov	eax,17		       ; get id
   int	0x40
   cmp	ah,1		       ; button id=1 ?
   jne	noclose
   mov	eax,-1		       ; close this program
   int	0x40
noclose:
   jmp	still

draw_window:
   startwd
   window   40,40,(510+9),(234+26),window_Skinned+0x00ffffff
   label    8,8,'InformationBox - ReadMe.TxT ',cl_White+font_Big

   mov ebp,vscroll
   call redrawvscroll
   call showtext

   endwd
   ret

; DATA AREA
IM_END:

vscroll:
vscroll_x dd 495  ;0
vscroll_y dd 40   ;4
vscroll_xs dd 16  ;8
vscroll_ys dd 200 ;12
vscroll_bglc dd 0x0088aabb  ;scroll line backg color ;16
vscroll_ubs dd 16 ;up button size                    ;20
vscroll_ubc dd 0x002255aa   ;scroll up button color
vscroll_dbs dd 16 ;down button size
vscroll_dbc dd 0x002255aa   ;scroll down button color 32
vscroll_smbc dd 0x002244aa   ;scroll movment box color 36
vscroll_minr dd 0  ;minimum range 40
vscroll_maxr dd 400  ;maximum range 44
vscroll_nowpos dd 0  ;now pos in range 48
vscroll_sor dd 20 ;size of range >0 52
vscroll_mstat dd 0 ;mouse status 56
vscroll_redstat dd 0 ;redrawstatus 60 if 1 - neded redraw!
vscroll_mmlpos dd 0 ;movment box y when click 64
vscroll_bglpcol dd 0x00668899 ;bgl pressed color 68
vscroll_upbpcol dd 0x00223377 ;upb pressed color 72
vscroll_dnbpcol dd 0x00223377 ;dnb pressed color 76
vscroll_mmbpcol dd 0x00224477 ;mmb pressed color 80
vscroll_stylemap dd 0011111111111b  ;use colors or images? 84
;style map 876543210b
; 0-ub up
; 1-ub down
; 2-db up
; 3-db down
; 4-bgl up
; 5-bgl down
; 6-mmall up
; 7-mmall down
; 8-fadeed up
; 9-fadeed dn
; 10-fadeed bgl
vscroll_ubupimg dd ubup+8  ;offset to up but up image 88
vscroll_ubdnimg dd ubdn+8  ;offset to up but down image 92
vscroll_dbupimg dd dbup+8  ;offset to down but up image 96
vscroll_dbdnimg dd dbdn+8  ;offset to down but down image 100
vscroll_bglupimg dd bglup+8  ;offset to bgl up image 104
vscroll_bgldnimg dd bgldn+8  ;offset to bgl down image 108
vscroll_bglimgsz dd 2  ;offset to bgl up/down image size 112
vscroll_mm1upimg dd mm1up+8  ;116
vscroll_mm2upimg dd mm2up+8  ;120
vscroll_mm3upimg dd mm3up+8  ;124
vscroll_mm123size dd 2	;mm123updn  size 128
vscroll_mm1dnimg dd mm1dn+8  ;132
vscroll_mm2dnimg dd mm2dn+8  ;136
vscroll_mm3dnimg dd mm3dn+8  ;140
vscroll_ubfimg dd ubfade+8  ;144
vscroll_dbfimg dd dbfade+8  ;148
vscroll_bglfimg dd bglfade+8  ;152
vscroll_ubfcol dd 0x00ff00ff  ;156
vscroll_dbfcol dd 0x00ff00ff  ;160
vscroll_bglfcol dd 0x00ff00ff  ;164
vscroll_mmboxminsize dd 6  ; minimal size of movmentbox 168

temp dd 0

fileinfo:
dd 0 ;read
dd 0x0 ;start block
dd 200 ;how blocks read
dd itext  ;to text
dd param_area ; 4096 bytes for OS
;db '/RD/1/ROSE.txt',0
db '/RD/1/MACROS.INC',0


bmpfile:
file 'winscrl.bmp'

itext:
rb 51200*2
text:
rb 51200*2

imgstruc:
rb 16*16*8*3+8
ubup:
rb 16*16*3+8
ubdn:
rb 16*16*3+8
dbup:
rb 16*16*3+8
dbdn:
rb 16*16*3+8
bglup:
rb 16*16*3+8
bgldn:
rb 16*16*3+8
mm1up:
rb 16*16*3+8
mm2up:
rb 16*16*3+8
mm3up:
rb 16*16*3+8
mm1dn:
rb 16*16*3+8
mm2dn:
rb 16*16*3+8
mm3dn:
rb 16*16*3+8
ubfade:
rb 16*16*3+8
dbfade:
rb 16*16*3+8
bglfade:
rb 16*16*3+8

param_area rd 8000
I_END:
