;-------------------------
; kxDialog event handler

ret
;-------------------------------------------------------------------------------
; register a new widget
_kx_register_w:
    cmp [_kx_wi],0
    jnz _kx_no_main
    mov [_kx_woff],edi
  _kx_no_main:
    mov eax,[_kx_wi]
    inc eax
    mov [_kx_wp+eax*4],edi		  ; in edi we got the widget offset
    mov [_kx_wi],eax
    mov [_kx_count],eax
    mov eax,0
ret

;-------------------------------------------------------------------------------
; the key event handler
; ebx: pointer to actual widget while walking
; ecx: index of widgets
k_event_hnd:			      ; this lable does nothing, but is used as
				      ; interface to userprog,because we dont
				      ; want use the _kx_ name space for user progs
; ALT-F4   close app
    cmp ah,53
    jne @f
    mcall -1
  @@:
    call _kx_find_focus_widget	      ; which widget has the focus?
; ENTER clicks the widget
    cmp ah,13
    jne @f
    ; in [edi] now we have the offset of focussed widget
    mov eax,[edi+32]
    shl eax,8			      ; btn id is in offset+34, so move it for button handler
    call _kx_b_event_hnd	      ; we simulate  a click event
    jmp no_close; _kx_end_event
;  _kx_not_enter:
  @@:
; TAB set focus to next widget
    cmp ah,9
    jne @f
    and [edi+32], dword not hasFocus	; clear bit 15, unset focus
  _kx_cont_counter:
    inc ecx				; jump forward to next widget
    cmp ecx,[_kx_count] 		; if we are at last widget
    jg _kx_reset_counter		; begin again with first one
    mov edi,[_kx_wp+ecx*4]
    mov eax,[edi]
    cmp eax,_kxButton			; is it a clickable widget?
    jl _kx_cont_counter 		; no, lets try next
    mov eax,[edi+32]
    shl eax,16              ; its allowed to set the focus? (bit 16, canFocus set)
    cmp eax,0
    je _kx_cont_counter
;mov [dbg],eax
;mov [dbg2],edi
    or [edi+32], dword hasFocus 	; set its focus
    jmp @f				; ready, lets go
  _kx_reset_counter:
    mov ecx,1				; reset counter position, 0 is the window, it never has focus
    jmp _kx_cont_counter
    jmp _kx_end_event
  @@:
ret

;-------------------------------------------------------------------------------
; the button event handler
; ebx: pointer to actual widget while walking
; ecx: index of widgets
b_event_hnd:			      ; this lable does nothing, but is used as
				      ; interface to userprog,because we dont
				      ; want use the _kx_ name space for user progs
_kx_b_event_hnd:
    push eax
    shr eax,24			      ; button 1 is out of this handler.
    cmp eax,1			      ; so lets check, wether this one is entered
    jg @f
mov [dbg],eax
    mcall -1			      ; end exit, if yes
  @@:
    pop eax
    shr eax,16
mov [dbg2],eax
    call _kx_find_clicked_widget
    push eax
    shl eax,24			      ; lets see, if we can sat the focus
    cmp eax,0			      ; if bit 16 is set
    je _kx_nofocus
    or [edi+32],word hasFocus	      ; set the focus
  _kx_nofocus:
    pop eax
    cmp [edi],dword _kxCheckbox
    jne _kx_not_checkbox	      ; event dit not come from checkbox
    xor [edi+36],dword TRUE	      ; switch checked status
  _kx_not_checkbox:
    jmp _kx_c_walk_table
  _kx_end_event:
ret

;-------------------------------------------------------------------------------
; this routine is used for button event.
; ebx: pointer to actual widget while walking
; ecx: index of widgets
_kx_find_clicked_widget:
    mov ecx,0			      ; begin of widget index, 0 s the main window
;    mov ebx,[_kx_woff]                ; set pointer to offset
;    mov [_kx_wp],ecx
  _kx_c_walk_table:
    add ecx,1
    cmp ecx,[_kx_count]
    jg _kx_end_event		      ; we have checked all registered widgets
    mov edi,[_kx_wp+ecx*4]	      ; this is the offset of actual widget
    and [edi+32], dword not hasFocus  ; clear bit 15, unset focus
    cmp ah, byte [edi+34]	      ; compare wth id
    jne _kx_c_walk_table	      ; we didnt found the clcked widget
ret

;-------------------------------------------------------------------------------
; find out, which widget has focus
; ebx: pointer to actual widget while walking
; ecx: index of widgets
_kx_find_focus_widget:
    mov ecx,0			      ; begin of widget index, 0 s the main window
;    mov ebx,[_kx_woff]                ; set pointer to offset
;    mov [_kx_wp],ecx
  _kx_f_walk_table:
    add ecx,1
    cmp ecx,[_kx_count]
    jg _kx_end_event		      ; we have checked all registered widgets
    mov edi,[_kx_wp+ecx*4]	      ; this is the offset of actual widget
    push eax
    mov eax,[edi]
    cmp eax,_kxButton		      ; can this widget have focus?
    jl _kx_nohasfocus		      ; no, type of focusable widget is minimum _kxButton
    mov eax,[edi+32]
    shl eax,17			      ; lets see, if this widget has focus
    cmp eax,0
    je _kx_nohasfocus
    pop eax
    ret
  _kx_nohasfocus:
    pop eax
    jmp _kx_f_walk_table	      ; we didnt found the widget
ret