
include 'proc32.inc'

DLL_ENTRY equ 1
DLL_EXIT  equ -1
REQ_VER   equ 1

use32
        db      'MENUET01'
        dd      1
        dd      start
        dd      i_end
        dd      mem
        dd      mem
        dd      0
        dd      0

start:

        mov eax, 68
        mov ebx, 19
        mov ecx, dllname
        int 0x40

        test eax,eax
        jz exit
        mov [hDll], eax

        stdcall link, eax, imports
        mov eax, [dll_ver]
        cmp ax, REQ_VER
        jb exit
        shr eax, 16
        cmp ax, REQ_VER
        ja exit

        stdcall [dll_start], dword DLL_ENTRY
        test eax, eax
        jz exit

        push    caption
        push    -1
        push    -1
        push    -1
        push    -1
        call    [con_init]
        xor	ebx, ebx
@@:
        push    ebx
        push    t1
        push    7
        call    [con_printf]
        add     esp, 12
        push    text
        push    ebx
        call    [con_write_asciiz]
        inc	bl
        jnz	@b
        push    0
        call    [con_exit]
exit:
        or      eax, -1
        int     0x40

align 4
proc link stdcall, exp:dword, imp:dword
           mov esi, [imp]
           test esi, esi
           jz .done
.next:
           lodsd
           test eax, eax
           jz .done
           stdcall get_proc, [exp], eax
           mov [esi-4], eax
           jmp .next
.done:
           ret
endp

align 4
proc get_proc stdcall, exp:dword, sz_name:dword

	   mov edx, [exp]
.next:
	   test edx, edx
	   jz .end

	   stdcall strncmp, [edx], [sz_name], 16
	   test eax, eax
	   jz .ok

	   add edx,8
	   jmp .next
.ok:
	   mov eax, [edx+4]
.end:
	   ret
endp

align 4
proc strncmp stdcall, str1:dword, str2:dword, count:dword
;change eax, ebx, ecx

           push esi
           push edi
           mov ecx,[count]
           jecxz .end

           mov ebx,ecx

           mov edi,[str1]
           mov esi,edi
           xor eax,eax
           repne scasb
           neg ecx             ; cx = count - strlen
           add ecx,ebx         ; strlen + count - strlen

           mov edi,esi
           mov esi,[str2]
           repe cmpsb
           mov al,[esi-1]
           xor ecx,ecx

           cmp al,[edi-1]
           ja .str2_big
           je .end
.str1_big:
           sub ecx,2
.str2_big:
           not ecx
.end:
           mov eax,ecx
           pop edi
           pop esi
           ret
endp

align 4

imports:
dll_start          dd szStart
dll_ver            dd szVersion
con_init           dd szcon_init
con_write_asciiz   dd szcon_write_asciiz
con_printf         dd szcon_printf
con_exit           dd szcon_exit
                   dd 0

szStart            db 'START',0
szVersion          db 'version',0
szcon_init         db 'con_init',0
szcon_write_asciiz db 'con_write_asciiz',0
szcon_printf       db 'con_printf',0
szcon_exit         db 'con_exit',0

dllname  db '/rd/1/console.obj',0

caption            db 'Console test - colors',0
t1                 db ' 0x%02X: ',0
text               db ' ਬ ⥪.',10,0

i_end:
hDll               rd 1

align 4
rb 2048 ; stack
mem:
