; MtApPack = Menuet Applications Packer
; Kolibri version
; Written by diamond in 2006 specially for KolibriOS

; Uses aPLib compression library by Joergen Ibsen
; (for more information on aPLib visit http://www.ibsensoftware.com)

; Uses LZMA compression library by Igor Pavlov
; (for more information on LZMA and 7-Zip visit http://www.7-zip.org)
; (plain-C packer and ASM unpacker are ported by diamond)

	.486
	.model flat
extrn _aP_pack:proc
lzma_compress equ _lzma_compress@16
lzma_set_dict_size equ _lzma_set_dict_size@4
extrn lzma_compress:proc
extrn lzma_set_dict_size:proc
.data
	db	'MENUET01'
	dd	1
	dd	offset _start
	dd	offset bss_start	; i_end
memf	dd	offset bss_end		; memory
	dd	offset bss_end		; esp
	dd	offset params		; params
	dd	0		; icon

caption_str	db	'MtApPack'
caption_len	=	$ - caption_str
buttons1names	db	' InFile:'
		db	'OutFile:'
		db	'   Path:'
aStart		db	'START'
aStart_len	=	$ - aStart
bForceMemIncButton_str db 'Force memory size increasing, zero uninit data'
bForceMemIncButton_len = $ - bForceMemIncButton_str
definoutname	db	0
defpath		db	'/RD/1/'
curedit		dd	0

info_str	db	'MtApPack - Menuet/Kolibri Applications Packer, version 2.2',10
		db	'Uses aPLib v0.43 compression library',10
		db	'Uses LZMA  v4.32 compression library',10,10
info_len	=	$ - offset info_str
usage_str	db	'Written by diamond in 2006 specially for KolibriOS',10
		db	'aPLib is copyright (c) 1998-2005 by Joergen Ibsen',10
		db	'LZMA  is copyright (c) 1999-2005 by Igor Pavlov',10
		db	10
		db	'Command-line usage:',10
		db	' mtappack [-k] [-q] infile [outfile]',10
		db	'-k: keep memory size (if possible); use this option, if you know that',10
		db	'    uninitialized app data may not be zeroed (as does system loader)',10
		db	"-q: be quiet (don't create window, don't say anything)",10
		db	'If no output file is specified,',10
		db	'    packed data will be written back to input file',10
		db	10
		db	'Window usage:',10
		db	" enter input file name, output file name and press 'Start' button",10
usage_len	=	$ - usage_str
errload_str	db	'Cannot load input file',10
errload_len	=	$ - offset errload_str
outfileerr_str	db	'Cannot save output file',10
outfileerr_len	=	$ - offset outfileerr_str
nomem_str	db	'No memory',10
nomem_len	=	$ - offset nomem_str
not_exe_str	db	'Not Menuet/Kolibri executable!',10
not_exe_len	=	$ - offset not_exe_str
too_big_str	db	'failed, output is greater than input.',10
too_big_len	=	$ - too_big_str
icon_wrn_str	db	"Warning: 'full path' field in header seems to be ",10
		db	" invalid and will be ignored.",10
icon_wrn_len	=	$ - icon_wrn_str
compressing_str	db	'Compressing ... '
compressing_len = $ - compressing_str
lzma_nomem_str	db	'Warning: no memory for LZMA packer, will force aPLib',10
lzma_nomem_len = $ - lzma_nomem_str
lzma_memsmall_str db	'Warning: not enough memory for default LZMA settings,',10
		db	'         will use less dictionary size',10
lzma_memsmall_len = $ - lzma_memsmall_str

done_str	db	'OK! Compression ratio: '
ratio		dw	'00'
		db	'%',10
done_len	=	$ - done_str

; Loader is located in the end of packed exe and consists from:
; 1. Unpacker code
; 2. (if calltrick is used) Calltrick restore code
; 3. (if command-line is used) Parameters restore code
; 4. (if path is used) Path restore code
; 5. (for size optimization) aPLib: getbit proc; LZMA: addresses of unpacker subroutines
; 6. Code to move packed data and unpacker to safe area
; entry points to part 6

loader_aplib_common label byte
	db	 00h, 00h, 00h, 00h, 01h, 0Ah, 00h, 00h, 00h, 00h,0D2h, 75h, 05h, 8Ah, 16h, 46h
	db	 10h,0D2h,0C3h, 6Ah, 34h, 5Fh,0B2h, 80h,0A4h,0B6h,0C1h,0FFh,0D3h, 73h,0F9h, 31h
	db	0C0h,0FFh,0D3h, 73h, 2Dh,0FFh,0D3h, 73h, 11h,0B6h,0C1h, 41h,0B0h, 10h,0FFh,0D3h
	db	 10h,0C0h, 73h,0FAh, 75h, 41h,0AAh, 49h,0EBh,0E1h,0ACh,0D1h,0E8h, 74h, 42h, 11h
	db	0C9h,0EBh, 2Dh, 79h, 2Eh, 83h,0D9h, 01h, 74h, 08h, 91h, 48h,0C1h,0E0h, 08h,0ACh
	db	0B6h, 00h, 41h,0FFh,0D3h, 11h,0C9h,0FFh,0D3h, 72h,0F8h, 00h,0F6h, 75h,0E4h, 3Dh
	db	 00h, 7Dh, 00h, 00h, 73h, 0Ah, 80h,0FCh, 05h, 73h, 06h, 83h,0F8h, 7Fh, 77h, 02h
	db	 41h, 41h, 95h, 89h,0E8h,0B6h, 41h, 56h, 89h,0FEh, 29h,0C6h,0F3h,0A4h, 5Eh,0EBh
	db	 9Ah
loader_aplib_common_size = $ - loader_aplib_common
loader_lzma label byte
	db	 97h, 00h, 00h, 00h, 04h, 78h, 56h, 34h, 12h,0FFh,0FFh,0FFh,0FFh, 53h, 00h, 00h
	db	 00h, 00h, 00h, 00h, 00h, 52h, 8Bh, 53h,0F8h,0C1h,0EAh, 0Bh, 0Fh,0AFh, 10h, 39h
	db	 53h,0F4h, 73h, 18h, 89h, 53h,0F8h,0BAh, 00h, 08h, 00h, 00h, 2Bh, 10h,0C1h,0EAh
	db	 05h, 01h, 10h, 9Ch,0E8h, 13h, 00h, 00h, 00h, 9Dh, 5Ah,0C3h, 29h, 53h,0F8h, 29h
	db	 53h,0F4h, 8Bh, 10h,0C1h,0EAh, 05h, 29h, 10h,0F9h,0EBh,0E7h, 80h, 7Bh,0FBh, 00h
	db	 75h, 15h,0C1h, 63h,0F8h, 08h,0C1h, 63h,0F4h, 08h, 50h, 8Bh, 43h, 10h, 8Ah, 00h
	db	0FFh, 43h, 10h, 88h, 43h,0F4h, 58h,0C3h, 50h, 8Dh, 04h, 90h,0FFh, 13h, 58h,0C3h
	db	0B1h, 03h,0FFh, 13h, 73h, 1Ah, 83h,0C0h, 04h,0FFh, 13h, 72h, 08h, 8Dh, 54h,0D1h
	db	 7Eh, 6Ah, 08h,0EBh, 11h,0BAh, 01h, 01h, 00h, 00h,0B1h, 08h, 6Ah, 10h,0EBh, 06h
	db	0D3h,0E2h, 42h, 42h, 6Ah, 00h, 8Dh, 04h, 90h, 31h,0D2h, 42h, 51h,0FFh, 53h,0FCh
	db	 11h,0D2h,0E2h,0F9h, 59h, 0Fh,0BBh,0CAh, 59h, 01h,0D1h,0C3h, 31h,0EDh, 31h,0C0h
	db	 48h, 8Dh, 7Bh, 04h,0ABh,0ABh,0ABh, 96h,0ABh,0B5h, 20h,0B8h, 00h, 04h, 00h, 00h
	db	0BFh, 00h, 00h, 5Fh, 12h,0F3h,0ABh, 6Ah, 34h, 5Fh, 81h,0FFh, 50h, 41h, 52h, 45h
	db	 0Fh, 83h, 58h, 01h, 00h, 00h, 89h,0FAh, 83h,0E2h, 03h, 50h, 89h,0E8h,0C1h,0E0h
	db	 06h, 05h, 00h, 00h, 5Fh, 12h,0FFh, 53h,0FCh, 58h, 72h, 47h, 0Fh,0B6h,0C0h, 24h
	db	0E0h, 6Bh,0C0h, 60h, 05h,0D8h, 1Ch, 5Fh, 12h,0B2h, 01h, 83h,0FDh, 07h, 72h, 18h
	db	 8Ah, 0Ch, 37h, 00h,0C9h, 80h,0D6h, 01h,0FFh, 53h,0FCh, 10h,0D2h, 72h, 10h, 30h
	db	0D6h,0F6h,0C6h, 01h,0B6h, 00h, 75h,0EBh,0FFh, 53h,0FCh, 10h,0D2h, 73h,0F9h, 89h
	db	0E8h, 3Ch, 04h, 72h, 08h, 3Ch, 0Ah,0B0h, 03h, 72h, 02h,0B0h, 06h, 29h,0C5h, 92h
	db	0AAh,0EBh, 97h, 8Dh, 04h,0ADh, 00h, 03h, 5Fh, 12h,0FFh, 13h, 73h, 4Ch, 83h,0C0h
	db	 30h,0FFh, 13h, 72h, 1Dh, 89h,0E8h,0C1h,0E0h, 06h, 05h,0C0h, 03h, 5Fh, 12h,0FFh
	db	 53h,0FCh, 72h, 25h, 83h,0FDh, 07h, 19h,0EDh, 8Dh, 6Ch, 2Dh, 0Bh, 8Ah, 04h, 37h
	db	0EBh,0CEh, 83h,0C0h, 30h,0FFh, 13h, 87h, 73h, 04h, 73h, 0Dh, 83h,0C0h, 30h,0FFh
	db	 13h, 87h, 73h, 08h, 73h, 03h, 87h, 73h, 0Ch,0B8h,0D0h, 14h, 5Fh, 12h,0E8h,0EDh
	db	0FEh,0FFh,0FFh, 6Ah, 08h,0E9h, 8Eh, 00h, 00h, 00h, 87h, 73h, 04h, 87h, 73h, 08h
	db	 89h, 73h, 0Ch,0B8h,0C8h, 0Ch, 5Fh, 12h,0E8h,0D3h,0FEh,0FFh,0FFh, 6Ah, 03h, 5Ah
	db	 39h,0CAh, 72h, 02h, 89h,0CAh, 51h, 6Ah, 06h, 59h,0B8h,0C0h, 06h, 5Fh, 12h,0D3h
	db	0E2h,0E8h,0DEh,0FEh,0FFh,0FFh, 89h,0CEh, 83h,0F9h, 04h, 72h, 56h, 89h,0CAh, 31h
	db	0C0h,0D1h,0E9h, 14h, 02h, 49h,0D3h,0E0h, 89h,0C6h, 29h,0D0h, 8Dh, 04h, 85h,0BCh
	db	 0Ah, 5Fh, 12h, 83h,0FAh, 0Eh, 72h, 26h, 31h,0C0h,0D1h, 6Bh,0F8h, 01h,0C0h, 8Bh
	db	 53h,0F4h, 2Bh, 53h,0F8h, 72h, 05h, 89h, 53h,0F4h, 04h, 10h,0E8h, 5Bh,0FEh,0FFh
	db	0FFh, 49h, 83h,0F9h, 04h, 75h,0E3h, 01h,0C6h,0B8h, 88h, 0Ch, 5Fh, 12h, 57h, 31h
	db	0D2h, 42h, 89h,0D7h,0FFh, 53h,0FCh, 73h, 03h, 01h,0FEh,0F9h, 11h,0D2h, 01h,0FFh
	db	0E2h,0F2h, 5Fh, 59h,0F7h,0D6h, 6Ah, 07h, 83h,0FDh, 07h, 5Dh, 72h, 03h, 83h,0C5h
	db	 03h, 41h, 56h, 01h,0FEh,0F3h,0A4h,0ACh, 5Eh,0E9h, 02h,0FFh,0FFh,0FFh
lzma_size = 219h

calltrick db	 31h,0F6h,0B9h, 43h, 54h, 52h, 31h,0ACh, 2Ch,0E8h, 3Ch, 01h, 77h,0F9h, 80h, 3Eh
	db	 78h, 75h,0F4h,0ADh, 66h,0C1h,0E8h, 08h,0C1h,0C8h, 10h, 86h,0C4h, 29h,0F0h, 89h
	db	 46h,0FCh,0E2h,0E3h
calltrick_size = $ - calltrick
ctiptr1 = calltrick + 10h

calltrick2 db	 31h,0F6h,0B9h, 43h, 54h, 52h, 31h,0ACh, 3Ch, 0Fh, 75h, 09h,0ACh, 3Ch, 80h, 72h
	db	0F7h, 3Ch, 90h, 72h, 06h, 2Ch,0E8h, 3Ch, 01h, 77h,0ECh, 80h, 3Eh, 78h, 75h,0E7h
	db	0ADh, 66h,0C1h,0E8h, 08h,0C1h,0C8h, 10h, 86h,0C4h, 29h,0F0h, 89h, 46h,0FCh,0E2h
	db	0D6h
calltrick2_size = $ - calltrick2
ctiptr2 = calltrick2 + 1Dh

params_code db	 31h,0C0h,0B1h, 40h, 5Eh, 8Bh, 78h, 1Ch,0F3h,0A5h
params_code_len	= $ - params_code
path_code db     66h,0B9h, 00h, 01h, 31h,0C0h, 5Eh, 8Bh, 78h, 20h,0F3h,0A5h
path_code_len = $ - path_code

entry_code db	 6Ah, 24h, 5Eh,0BFh, 50h, 41h, 52h, 31h, 57h, 8Bh, 4Eh,0ECh,0F3h,0A4h, 5Eh, 8Dh
	db	 5Fh,0C1h,0E9h, 50h, 41h, 52h, 33h
entry_code_len = $ - entry_code

bForceMemInc db 1
bQuiet db 0

.data?
bss_start label byte

params	db	256 dup (?)

color_table dd	10 dup (?)
skinheight dd	?
aplib_size dd	?

innamelen dd	?
inname	db	48 dup (?)
outnamelen dd	?
outname	db	48 dup (?)
pathlen dd	?
path	db	48 dup (?)

curedit_y	dd	?

message_mem	db	80*20 dup (?)
message_cur_pos	dd	?

outsize		dd	?
infile		dd	?
outfile		dd	?
outfile1	dd	?
outfile2	dd	?
outfilebest	dd	?
inbuftmp	dd	?
workmem		dd	?
lzma_dictsize	dd	?
app_mem         dd      ?
app_esp         dd      ?
app_eip         dd      ?
app_i_param	dd	?
app_i_icon	dd	?
indelta		dd	?
cur_loader	dd	?
cur_loader_size	dd	?
used_calltrick_ptr dd	?
used_calltrick_size dd	?
params_ptr	dd	?
params_size	dd	?
path_ptr        dd      ?
path_size       dd      ?
ct1		db	256 dup (?)
ctn		dd	?
loader_aplib	db	200 dup (?)
cti		db	?
intype          db      ?
use_aplib	=	1
use_lzma	=	2

use_no_calltrick =	0
use_calltrick1	=	10h
use_calltrick2	=	20h

method			db	?
bNeedStackRebase	db	?

fn70block label byte
fn70op	dd	?
fn70start dd	?
fn70size dd	?
fn70zero dd	?
fn70dest dd	?
fullname db	100 dup (?)

align 4

file_attr       dd      8 dup (?)
insize          dd      ?       ; last qword in file_attr
                dd      ?

mtstack	db	1000h dup (?)
bss_end label byte

.code

clear_messages:
	xor	eax, eax
	mov	ecx, 80*20/4+1
	mov	edi, offset message_mem
	rep	stosd
	ret

_start:
	call	clear_messages
; set default path = /RD/1/
	mov	esi, offset defpath
	mov	edi, offset path
	mov	dword ptr [edi-4], 6
	movsw
	movsd
; get system window info
	mov	al, 48
	push	3
	pop	ebx
	mov	ecx, offset color_table
	push	40
	pop	edx
	int	40h
	inc	ebx
	int	40h
	mov	[skinheight], eax
; check command line
	mov	esi, offset params
	mov	byte ptr [esi+100h], 0
parse_opt:
	call	skip_spaces
	cmp	al, '-'
	jnz	short not_opt
	lodsb
	lodsb
	cmp	al, 'k'
	jz      short @f
	cmp     al, 'K'
	jnz	short not_opt_0
@@:
	mov	[bForceMemInc], 0
	jmp	short parse_opt
not_opt_0:
	cmp	al, 'q'
	jz	short @f
	cmp	al, 'Q'
	jnz	short default
@@:	mov	[bQuiet], 1
	jmp	short parse_opt
not_opt:
	test	al, al
	jz	short default
	mov	edi, offset inname
	call	copy_name
	test	al, al
	jz	short outeqin
	mov	edi, offset outname
	call	copy_name
	test	al, al
	jnz	short default
doit:
	cmp	[bQuiet], 0
	jnz	short @f
	call	draw_window
	call	pack
	jmp	waitevent
@@:
	call	pack
exit:
	xor	eax, eax
	dec	eax
	int	40h
outeqin:
	mov	ecx, 48/4+1
	mov	esi, offset inname-4
	mov	edi, offset outname-4
	rep	movsd
	jmp	short doit
default:
	mov	[bQuiet], 0
	mov	[curedit], offset inname
	mov	ecx, [skinheight]
	add	ecx, 5
	mov	[curedit_y], ecx
	mov	esi, offset definoutname
	mov	edi, esi
	xor	ecx, ecx
	xor	eax, eax
	dec	ecx
	repnz	scasb
	not	ecx
	dec	ecx
	mov	[innamelen], ecx
	push	ecx
	push	esi
	mov	edi, offset inname
	rep	movsb
	pop	esi
	pop	ecx
	mov	[outnamelen], ecx
	mov	edi, offset outname
	rep	movsb
dodraw:
	call	draw_window
waitevent:
	push	10
	pop	eax
	int	40h
	dec	eax
	jz	short dodraw
	dec	eax
	jz	keypressed
	dec	eax
	jnz	short waitevent
; button pressed
	mov	al, 17
	int	40h
	xchg	al, ah
	cmp	al, 6
	jz	short but6
	cmp	al, 7
	jz	short but7
	dec	eax
	jz	exit
	dec	eax
	jnz	short nopack
	call	pack
	jmp	short waitevent
but6:
	xor	[bForceMemInc], 1
	call	redraw_bForceMemInc
	jmp	short waitevent
but7:
	call	clear_messages
; display logo
	mov	esi, offset info_str
	push	info_len
	pop	ecx
	call	write_string
; display info
	mov	esi, offset usage_str
	mov	ecx, usage_len
	call	write_string
	jmp	short waitevent
nopack:
; this is infile/outfile/path button
	call	clear_edit_points
	mov	esi, offset inname
	mov	ecx, [skinheight]
	add	ecx, 5
	dec	eax
	jz	short edit
	mov	esi, offset outname
	add	ecx, 0Ch
	dec	eax
	jz	short edit
	mov	esi, offset path
	add	ecx, 0Ch
edit:
	cmp	esi, [curedit]
	mov	[curedit], 0
	jz	waitevent
	mov	[curedit], esi
	mov	[curedit_y], ecx
	mov	al, 1
	mov	ebx, [esi-4]
	mov	edi, ebx
	imul	ebx, 6
	add	ebx, 42h
	add	ecx, 4
	xor	edx, edx
@@:
	cmp	edi, 48
	jz	waitevent
	int	40h
	add	ebx, 6
	inc	edi
	jmp	@b
keypressed:
	mov	al, 2
	int	40h
	xchg	al, ah
	mov	edi, [curedit]
	test	edi, edi
	jz	waitevent
	mov	ebx, [edi-4]
	cmp	al, 8
	jz	short backspace
	cmp	al, 13
	jz	onenter
	cmp	al, 20h
	jb	waitevent
	cmp	ebx, 48
	jz	waitevent
	mov	[edi+ebx], al
	inc	ebx
	mov	[edi-4], ebx
; clear point and draw symbol
	lea	edi, [ebx+edi-1]
	imul	ebx, 6
	add	ebx, 40h-6
	shl	ebx, 16
	mov	al, 13
	mov	bl, 6
	mov	ecx, [curedit_y]
	push	ecx
	shl	ecx, 16
	mov	cl, 9
	mov	edx, [color_table+20]
	int	40h
	pop	ecx
	mov	bx, cx
	mov	edx, edi
	push	1
	pop	esi
	mov	ecx, [color_table+32]
	mov	al, 4
	int	40h
	jmp	waitevent
backspace:
	test	ebx, ebx
	jz	waitevent
	dec	ebx
	mov	[edi-4], ebx
; clear symbol and set point
	imul	ebx, 6
	add	ebx, 40h
	shl	ebx, 16
	mov	al, 13
	mov	bl, 6
	mov	ecx, [curedit_y]
	push	ecx
	shl	ecx, 16
	mov	cl, 9
	mov	edx, [color_table+20]
	int	40h
	xor	edx, edx
	shr	ebx, 16
	inc	ebx
	inc	ebx
	pop	ecx
	add	ecx, 4
	mov	al, 1
	int	40h
	jmp	waitevent
onenter:
	cmp	[curedit], offset inname
	jnz	short @f
	push	2
	pop	eax
	jmp	nopack
@@:	cmp	[curedit], offset outname
	jnz	short @f
	call	pack
	jmp	waitevent
@@:	call	clear_edit_points
	jmp	waitevent

pack:
	cmp	[bQuiet], 0
	jnz	short @f
	call	clear_edit_points
	and	[curedit], 0
; clear messages
	call	clear_messages
; display logo
	mov	esi, offset info_str
	push	info_len
	pop	ecx
	call	write_string
@@:
; load input file
	mov	esi, offset inname
	call	get_full_name
	mov	ebx, offset fn70block
	mov	dword ptr [ebx], 5
	and	dword ptr [ebx+4], 0
	and	dword ptr [ebx+8], 0
	and     dword ptr [ebx+12], 0
	mov	dword ptr [ebx+16], offset file_attr
	push	70
	pop	eax
	int	40h
	test	eax, eax
	jz	short inopened
infileerr:
	mov	esi, offset errload_str
	push	errload_len
	pop	ecx
	jmp	write_string
inopened:
        mov     ebx, [insize]
	cmp	ebx, 24h
	jbe	short infileerr
; maximum memory requests: 2*insize + 2*(maxoutsize+400h) + worksize
	mov	esi, [memf]
	mov	[infile], esi
	add	esi, ebx
	mov	[inbuftmp], esi
	add	esi, ebx
	mov	[outfile], esi
	mov	[outfile1], esi
	mov	[outfilebest], esi
	mov	ecx, ebx
	shr	ecx, 3
	add	ecx, ebx
	add	ecx, 400h
	add	esi, ecx
	mov	[outfile2], esi
	add	esi, ecx
	mov	[workmem], esi
	add	ecx, ebx
	add	ecx, ecx
	add	ecx, [memf]
; LZMA requires 0x509000 + dictsize*9.5 bytes for workmem,
; aPLib requires 0xA0000
	and	[lzma_dictsize], 0
	push	ecx
	mov	eax, ebx
	dec	eax
	bsr	ecx, eax
	inc	ecx
	cmp	ecx, 28
	jb	short @f
	mov	cl, 28
@@:
	mov	edx, ecx
	xor	eax, eax
	inc	eax
	shl	eax, cl
	imul	eax, 19
	shr	eax, 1
	add	eax, 509000h
	pop	ecx
	push	ecx
	add	ecx, eax
	push	64
	pop	eax
	push	1
	pop	ebx
	int	40h
	test	eax, eax
	jz	short mem_ok
; try to use smaller dictionary
meml0:
	cmp	edx, 4
	jbe	short memf1
	dec	edx
	xor	eax, eax
	inc	eax
	mov	ecx, edx
	shl	eax, cl
	imul	eax, 19
	shr	eax, 1
	add	eax, 509000h
	pop	ecx
	push	ecx
	add	ecx, eax
	push	64
	pop	eax
	int	40h
	test	eax, eax
	jnz	short meml0
; ok, say warning and continue
	mov	[lzma_dictsize], edx
	mov	esi, offset lzma_memsmall_str
	push	lzma_memsmall_len
	pop	ecx
	call	write_string
	jmp	short mem_ok
memf1:
; no memory for LZMA, try only aPLib
	or	[lzma_dictsize], -1
	pop	ecx
	push	ecx
	add	ecx, 0A0000h
	push	64
	pop	eax
	int	40h
	test	eax, eax
	jz	short meml1
	pop	ecx
	mov	esi, offset nomem_str
	push	nomem_len
	pop	ecx
	jmp	write_string
meml1:
	mov	esi, offset lzma_nomem_str
	push	lzma_nomem_len
	pop	ecx
	call	write_string
mem_ok:
	pop	ecx
	mov	eax, [insize]
	mov	ebx, offset fn70block
	mov     byte ptr [ebx], 0
	mov	[ebx+12], eax
	mov	esi, [infile]
	mov	[ebx+16], esi
	push	70
	pop	eax
	int	40h
	test	eax, eax
	jnz	infileerr
	lodsd
	cmp	eax, 'UNEM'
	jnz	short not_menuet_exe
	lodsw
	cmp	ax, 'TE'
	jnz	short not_menuet_exe
	xor	eax, eax
	lodsw
	xchg	al, ah
	sub	ax, '00'
	cmp	eax, 1
	jz	short menuet01
	jb	short menuet00
not_menuet_exe:
	mov	esi, offset not_exe_str
	push	not_exe_len
	pop	ecx
	jmp	write_string
menuet01:
        mov     eax, [esi+18h-8]
        mov     [app_esp], eax
	mov	eax, [esi+1Ch-8]
	mov	[app_i_param], eax
	mov	eax, [esi+20h-8]
	mov	[app_i_icon], eax
	mov     [intype], 1
; some stupid apps (such as 'desktop') begin from offset 0x20 and overwrite app_i_icon
	cmp	eax, [esi+14h-8]
	jb	short ok_sig
	mov	esi, offset icon_wrn_str
	push	icon_wrn_len
	pop	ecx
	call	write_string
	jmp	short zero_icon
menuet00:
	mov	eax, [esi+18h-8]
	mov	[app_i_param], eax
	mov     eax, [esi+14h-8]
	shr     eax, 1
	sub     eax, 10h
	mov     [app_esp], eax
	mov     [intype], 0
zero_icon:
	and	[app_i_icon], 0
ok_sig:
        mov     eax, [esi+0Ch-8]
        mov     [app_eip], eax
        mov     eax, [esi+14h-8]
        mov     [app_mem], eax
	mov	esi, offset loader_aplib_common
	mov	edi, offset loader_aplib
	mov	ecx, loader_aplib_common_size
	rep	movsb
	mov	[aplib_size], 78h
; for small files make aPLib loader smaller
	mov	edi, offset loader_aplib + 5Fh
	mov	eax, [insize]
	cmp	eax, 65536
	ja	short aplib_no_modify
; <=65536 => modify 'cmp eax,32000' to 'cmp ah,32000/256'
; 3D 00 7D 00 00 -> 80 FC 7D
	inc	ecx
	inc     ecx
	mov	dword ptr [edi+1], 7DFC8000h
	cmp	eax, 32000
	ja	short aplib_do_modify
; <= 32000 => delete commands 'cmp eax,32000 / jae ...'
	mov	cl, 7
	cmp	eax, 500h
	ja	short aplib_do_modify
; <= 500h => delete commands 'cmp ah,5 / jae ...'
	mov	cl, 7+5
aplib_do_modify:
; delete ecx bytes from edi
	lea	esi, [ecx+edi]
	mov	edx, ecx
	push	edi
	neg	ecx
	add	ecx, loader_aplib_common_size - 5Fh
	rep	movsb
	sub	[aplib_size], edx
	pop	edi
; correct jumps
	mov	esi, offset loader_aplib
	mov	ecx, loader_aplib_common_size
	sub	ecx, edx
mjl:
	lodsb
	cmp	al, 0EBh
	jz	short mjjm
	cmp	al, 70h
	jb	short mjc
	cmp	al, 79h
	ja	short mjc
mjjm:
	lodsb
	movsx	eax, al
	add	eax, esi
	cmp	eax, edi
	jbe	short @f
	sub	eax, edx
@@:
	cmp	esi, edi
	jbe	short @f
	add	eax, edx
@@:
	sub	eax, esi
	mov	[esi-1], al
mjc:
	loop	mjl
aplib_no_modify:
	mov	eax, [outfile]
	mov	dword ptr [eax], 'UNEM'
	mov	dword ptr [eax+4], '10TE'
	mov	dword ptr [eax+8], 1
	mov	edi, eax
	mov	ecx, 12
	mov	esi, [infile]
	repz	cmpsb
	jz	@f
	dec	edi
@@:	sub	edi, eax
	mov	eax, edi
	mov	[indelta], eax
; set LZMA dictionary size
	mov	eax, [lzma_dictsize]
	test	eax, eax
	js	short no_lzma_setds
	jnz	short lzma_setds
	mov	ecx, [insize]
	sub	ecx, eax
	dec	ecx
	bsr	eax, ecx
	inc	eax
	cmp	eax, 28
	jb	short lzma_setds
	mov	eax, 28
lzma_setds:
	push	eax
	call	lzma_set_dict_size
no_lzma_setds:
	push	compressing_len
	pop	ecx
	mov	esi, offset compressing_str
	call	write_string
	mov	[method], use_aplib
	mov	[bNeedStackRebase], 0
	or      [outsize], -1
	cmp     [lzma_dictsize], 0
	jl      short aplib1
	cmp     word ptr [insize+2], 0
	jnz     short @f
aplib1:
	call	pack_aplib
	add	eax, [aplib_size]
	mov	[outsize], eax
@@:
	mov	eax, [outfile2]
	mov	[outfile], eax
	xchg	eax, edi
	mov	esi, [outfile1]
	movsd
	movsd
	movsd
	cmp	[lzma_dictsize], 0
	jl	short @f
	call	pack_lzma
	add	eax, lzma_size
	cmp	eax, [outsize]
	jae	short @f
	mov	[outsize], eax
	mov	eax, [outfile]
	mov	[outfilebest], eax
	mov	[method], use_lzma
@@:
	call	preprocess_calltrick
	test	eax, eax
	jz	short noct1
	call	set_outfile
	cmp     [lzma_dictsize], 0
	jl      short aplib2
	cmp     word ptr [insize+2], 0
	jnz     short @f
aplib2:
	call	pack_aplib
	add	eax, calltrick_size
	add	eax, [aplib_size]
	cmp	eax, [outsize]
	jae	short @f
	mov	[outsize], eax
	mov	eax, [outfile]
	mov	[outfilebest], eax
	mov	[method], use_aplib or use_calltrick1
@@:
	cmp	[lzma_dictsize], 0
	jl	short @f
	call	set_outfile
	call	pack_lzma
	add	eax, calltrick_size + lzma_size
	cmp	eax, [outsize]
	jae	short @f
	mov	[outsize], eax
	mov	eax, [outfile]
	mov	[outfilebest], eax
	mov	[method], use_lzma or use_calltrick1
@@:
noct1:
	call	set_outfile
	push	[ctn]
	mov	al, [cti]
	push	eax
	call	preprocess_calltrick2
	test	eax, eax
	jz	noct2
	cmp     [lzma_dictsize], 0
	jl      short aplib3
	cmp     word ptr [insize+2], 0
	jnz     short @f
aplib3:
	call	pack_aplib
	add	eax, calltrick2_size
	add	eax, [aplib_size]
	cmp	eax, [outsize]
	jae	short @f
	mov	[outsize], eax
	mov	eax, [outfile]
	mov	[outfilebest], eax
	mov	[method], use_aplib or use_calltrick2
	pop	ecx
	pop	ecx
	push	[ctn]
	mov	al, [cti]
	push	eax
@@:
	cmp	[lzma_dictsize], 0
	jl	short @f
	call	set_outfile
	call	pack_lzma
	add	eax, calltrick2_size + lzma_size
	cmp	eax, [outsize]
	jae	short @f
	mov	[outsize], eax
	mov	eax, [outfile]
	mov	[outfilebest], eax
	mov	[method], use_lzma or use_calltrick2
	pop	ecx
	pop	ecx
	push	[ctn]
	mov	al, [cti]
	push	eax
@@:
noct2:
	pop	eax
	mov	[cti], al
	pop	[ctn]
	mov	esi, offset calltrick+2
	mov	ecx, calltrick_size
	test	[method], use_calltrick1
	jnz	short @f
	mov	esi, offset calltrick2+2
	mov	ecx, calltrick2_size
	test	[method], use_calltrick2
	jz	short pack_common
@@:
	sub	[outsize], ecx
; modify calltrick loader
	mov	eax, [ctn]
	cmp	eax, 0FFFFh
	ja	short ctml1
	cmp	eax, 0FFh
	ja	short ctml2
; mov ecx,xx -> mov cl,xx
	sub	ecx, 3
	add	esi, 3
	mov	byte ptr [esi], 0B1h
	mov	[esi+1], al
	jmp	short ctml3
ctml2:
; mov ecx,xx -> mov cx,xx
	dec	ecx
	inc	esi
	mov	word ptr [esi], 0B966h
	mov	[esi+2], ax
	jmp	short ctml3
ctml1:
	mov	byte ptr [esi], 0B9h
	mov	[esi+1], eax
ctml3:
; after aPLib unpacker eax=0
	test	[method], use_aplib
	jnz	short ctml4
	dec	esi
	dec	esi
	mov	word ptr [esi], 0F631h	; xor esi,esi
	jmp	short ctml5
ctml4:
	dec	esi
	dec	ecx
	mov	byte ptr [esi], 96h	; xchg eax,esi
ctml5:
	mov	[used_calltrick_ptr], esi
	mov	[used_calltrick_size], ecx
	mov	al, [cti]
	mov	[ctiptr1], al
	mov	[ctiptr2], al
pack_common:
	mov	[cur_loader], offset loader_lzma
	mov	eax, lzma_size
	test	[method], use_aplib
	jz	short @f
	mov	[cur_loader], offset loader_aplib
	mov	eax, [aplib_size]
@@:
	sub	[outsize], eax
	mov	[cur_loader_size], eax
; path
        and     [path_ptr], 0
        and     [path_size], 0
        cmp     [app_i_icon], 0
        jz      short nph1
        mov     esi, offset path_code
        mov     ecx, path_code_len
        mov     dword ptr [esi], 100B966h
        mov     word ptr [esi+2], 0C031h
; after aPLib unpacker code eax=ecx=0
; after LZMA unpacker code ecx=000000xx
; after calltrick preprocessing ecx=0
; after parameters restore eax=ecx=0
        cmp     [app_i_param], 0
        jnz     ph1
        cmp     [method], use_aplib
        jnz     short @f
ph1:
; there is cmdline or we use aplib w/o calltrick
; it is safe to delete 'xor eax,eax'
        lodsd
        dec     esi
        dec     esi
        mov     [esi], eax
        dec     ecx
        dec     ecx
@@:
        cmp     [app_i_param], 0
        jnz     ph2
        cmp     [method], use_lzma
        jz      short @f
ph2:
; there is cmdline or we don't use lzma w/o calltrick
; it is safe to replace 'mov cx,100' -> 'mov ch,1'
	inc	esi
	inc	esi
	dec	ecx
	dec	ecx
	mov	word ptr [esi], 01B5h
@@:
        mov     [path_ptr], esi
        mov     [path_size], ecx
nph1:
; parameters
	and	[params_ptr], 0
	and	[params_size], 0
	cmp	[app_i_param], 0
	jz	short npl1
	mov	esi, offset params_code
	mov	ecx, params_code_len
; after aPLib unpacker code eax=ecx=0
; after LZMA unpacker code ecx=000000xx
; after calltrick preprocessing ecx=0
; so for aPLib w/o calltrick we may delete instruction 'xor eax,eax'
	cmp	[method], use_aplib
	jnz	short @f
	inc     esi
	inc     esi
	dec	ecx
	dec	ecx
@@:
	mov	[params_ptr], esi
	mov	[params_size], ecx
npl1:
	mov	eax, [outsize]
	add	eax, [cur_loader_size]
	add	eax, 24h
	test	[method], use_calltrick1 or use_calltrick2
	jz	short npl2
	add	eax, [used_calltrick_size]
	cmp	[cti], 1
	ja	short npl2
	jz	short npl3
	dec	eax
npl3:
	dec	eax
npl2:
	add	eax, [params_size]
	add     eax, [path_size]
	cmp     [app_i_param], 0
	jz      short @f
	cmp     [app_i_icon], 0
	jz      short @f
	dec     eax
@@:
        cmp     [app_i_param], 0
        jz      short npl4
        add     eax, 3
        jmp     short @f
npl4:
        cmp     [app_i_icon], 0
        jz      short @f
        inc     eax
        inc     eax
@@:
	add	eax, 3+5
	cmp	[method], use_lzma
	jnz	short @f
	cmp	[app_i_param], 0
	jnz	short @f
	cmp     [app_i_icon], 0
	jnz     short @f
	inc	eax
	inc	eax
@@:
	test	[method], use_aplib
	jnz	short @f
	mov	ecx, [cur_loader]
	movzx	ecx, byte ptr [ecx+4]
	lea	eax, [eax+ecx*4]
@@:
	mov	esi, eax
	add	eax, entry_code_len
	cmp	eax, [insize]
	jb	short packed_ok
	mov	esi, offset too_big_str
	push	too_big_len
	pop	ecx
	jmp	write_string
packed_ok:
; set header
	mov	edi, [outfilebest]
	mov	[edi+12], esi		; app_start
	mov	[edi+16], eax		; app_i_end
	mov	ecx, [app_mem]
	mov	[edi+20], ecx		; app_mem
	mov     ecx, [app_esp]
	mov	[edi+24], ecx		; app_esp
	and	dword ptr [edi+28], 0   ; app_i_param (to be filled)
	and     dword ptr [edi+32], 0   ; app_i_icon (to be filled)
; find destination memory
	cmp	[app_i_param], 0
	jz	short @f
	add	eax, 256
@@:
        cmp     [app_i_icon], 0
        jz      short @f
        add     eax, 1024
@@:
; LZMA unpacker needs some (uninitialized) memory
	push	eax
	test	[method], use_lzma
	jz	short @f
	add	eax, 8000h +3+3
@@:
; we need eax bytes of additional memory
; memory map: (inclusive..exclusive)
; 0..[insize] : here will be unpacked output
; esp-30h..esp : stack (note that if it intercepts with 1st region, loader stack must be changed)
; if command line is used: app_i_param..app_i_param+100h : parameters
; if path is used: app_i_icon..app_i_icon+400h : path
	mov	ecx, [edi+24]
	sub	ecx, 30h
	mov	edx, [app_i_param]
	add	edx, 100h
	cmp	edx, [insize]
	ja	short @f
	mov	edx, [insize]
@@:	sub	ecx, edx
	jae	short @f
; hmm... probably this is @rcher or similar app, and stack is between main code and params?
	add	ecx, edx
	cmp	ecx, [insize]
	jb	short stack_err
	mov	ecx, [edi+24]
	cmp	ecx, [app_i_param]
	jbe	short place_mem_test1
stack_err:
	mov	[bNeedStackRebase], 1
	add	eax, 30h
	mov	edx, [app_i_param]
	add	edx, 100h
	cmp	edx, [insize]
	ja	short place_mem_test1
	mov	edx, [insize]
	jmp	short place_mem_test1
@@:
	cmp	[bForceMemInc], 0
	jz	short @f
place_mem_test2:
	mov	edx, [edi+20]
	jmp	short place_mem_test
place_mem_test1:
	cmp	[bForceMemInc], 0
	jz	short place_mem_test
	jnz	short place_mem_test2
@@:
	cmp	ecx, eax
	jae	short place_found
; if no place between (file+parameters) and stack, then use high location - after stack
	mov	edx, [edi+24]
; probably we need to increase memory size?
place_mem_test:
	lea	ecx, [eax+edx]
	cmp	ecx, [edi+20]
	jbe	short place_found
	mov	[edi+20], ecx
place_found:
; edx contains additional place
	mov	esi, 5
	cmp	[bNeedStackRebase], 0
	jz	short pfnsr
	and	ecx, not 3	; make esp dword-aligned
	mov	[edi+24], ecx
	cmp     [intype], 0
	jz	short pfcmn
	mov	esi, 2
pfnsr:
	sub	[edi+12], esi
	sub	[edi+16], esi
	sub	[esp], esi
pfcmn:
        mov     eax, edx
        add     eax, [edi+16]
        cmp     [app_i_param], 0
        jz      short @f
        mov     [edi+28], eax
        add     eax, 256
@@:
        cmp     [app_i_icon], 0
        jz      short @f
        mov     [edi+32], eax
@@:

; setup loader
	add	edi, 24h
	add	edi, [outsize]
	mov	ecx, [cur_loader_size]
	mov	esi, [cur_loader]
	add	esi, 4
	xor	eax, eax
	lodsb
	lea	esi, [esi+eax*4]
	push	edi
	test	[method], use_aplib
	jz	short @f
	sub	ecx, [esi-4]
	add	esi, [esi-4]
@@:
	rep	movsb
	and	dword ptr [edi], 0
	xchg	edi, [esp]
	mov	al, byte ptr [indelta]
	test	[method], use_lzma
	jnz	short lzma_loader_set
	mov	[edi+1], al
	jmp	short aplib_loader_set
lzma_loader_set:
	mov	[edi+0B3h], al
	mov	eax, [insize]
	mov	[edi+0B7h], eax
	mov	eax, [esp+4]
	sub	eax, 125F0000h
	add	eax, edx
	add	eax, 3+3
	and	al, not 3
@@:
	cmp	dword ptr [edi], 125F0000h
	jb	short llsc
	cmp	dword ptr [edi], 125F8000h
	jae	short llsc
	add	[edi], eax
	add	edi, 3
llsc:
	inc	edi
	cmp	edi, [esp]
	jb	short @b
aplib_loader_set:
	pop	edi
	pop	ecx
	test	[method], use_calltrick1 or use_calltrick2
	jz	short @f
	mov	esi, [used_calltrick_ptr]
	mov	ecx, [used_calltrick_size]
	sub	ecx, 10h
	rep	movsb
	cmp	[cti], 1
	jb	short als0
	jz	short als1
	movsd
	jmp	short als2
als1:
; 'shr ax,8' -> 'dec eax/xchg al,ah'
	mov	al, 48h
	stosb
	dec	byte ptr [esi+0Fh]
als0:
; 'shr ax,8' -> 'xchg al,ah'
	mov	ax, 0C486h
	stosw
	add	byte ptr [esi+0Fh], 2
	add	esi, 4
als2:
	mov	ecx, 0Ch
	rep	movsb
@@:
	cmp	[app_i_param], 0
	jz	short @f
	mov	esi, [params_ptr]
	mov	ecx, [params_size]
	rep	movsb
	cmp     [intype], 0
	jnz	short @f
	mov	byte ptr [edi-3], 18h
@@:
        cmp     [app_i_icon], 0
        jz      short noicon
        mov     esi, [path_ptr]
        mov     ecx, [path_size]
        sub     ecx, 5
        rep     movsb
;        cmp     [app_i_param], 0
;        jz      short @f
;        dec     edi
;@@:
        cmp     [app_i_param], 1
        adc     edi, 0
        dec     edi
        movsd
        movsb
noicon:
	cmp	[method], use_lzma
	jnz	short @f
	cmp	[app_i_param], 0
	jnz	short @f
	cmp     [app_i_icon], 0
	jnz     short @f
	mov	ax, 0C931h	; 31 C9 = xor ecx,ecx
	stosw
@@:
	cmp	[bNeedStackRebase], 0
	jz	short no_stack_rebase
	cmp     [intype], 0
	jz	short stack0_rebase
; mov esp,[ecx+18h] = 8B 61 18
	mov	ax, 618Bh
	stosw
	mov	al, 18h
	stosb
	jmp	short no_stack_rebase
stack0_rebase:
; mov esp,xxxxxxxx = BC xxxxxxxx
	mov	al, 0BCh
	stosb
	mov	eax, [app_esp]
	stosd
no_stack_rebase:
; jmp [ecx+0xC] = FF 61 0C
	mov	ax, 61FFh
	stosw
	mov	al, 0Ch
	stosb
	mov	esi, [cur_loader]
	add	esi, 4
	xor	eax, eax
	lodsb
	xchg	eax, ecx
	test	[method], use_lzma
	jz	short apli1
	mov	eax, edi
	sub	eax, [outfilebest]
	add	eax, edx
	and	eax, 3
	jz	short aligned
	sub     eax, 4
	neg     eax
	add     edx, eax
	push    edi
	mov     edi, [outfilebest]
	cmp     dword ptr [edi+28], 0
	jz      @f
	add     [edi+28], eax
@@:
        cmp     dword ptr [edi+32], 0
        jz      @f
        add     [edi+32], eax
@@:
        mov     edi, [params_ptr]
        test    edi, edi
        jz      @f
        add     [edi-9], eax
@@:
        pop     edi
aligned:
	movsd
	movsd
	dec	ecx
	dec	ecx
@@:
	lodsd
	add	eax, edx
	add	eax, [outsize]
	stosd
	loop	@b
	jmp	short apli2
apli1:
	lodsd
	xchg	eax, ecx
	rep	movsb
apli2:
; entry code
	mov	esi, offset entry_code
	mov	ecx, entry_code_len
	push	edi
	rep	movsb
	pop	edi
	mov	[edi+4], edx
	mov	ecx, [outfilebest]
	mov	eax, [cur_loader]
	mov	eax, [eax]
	add	eax, edx
	add	eax, [outsize]
	sub	eax, edi
	sub	eax, entry_code_len
	add	eax, [outfilebest]
	mov	[edi+13h], eax
	test	[method], use_aplib
	jz	short @f
	mov	byte ptr [edi+11h], 0BBh
@@:
        mov     ecx, entry_code_len - 3
        mov     eax, [outfilebest]
        cmp     [app_i_param], 0
        jz      short entry_no_param
        lea     esi, [edi+entry_code_len-1]
        lea     edi, [esi+3]
        std
        rep     movsb
        cld
        mov     byte ptr [edi], 0F8h
        mov     word ptr [edi-2], 76FFh
        sub     byte ptr [edi+15], 3
        sub     dword ptr [edi+17], 3
        sub     dword ptr [eax+12], 3
        jmp     entry_setup_done
entry_no_param:
        cmp     [app_i_icon], 0
        jz      entry_setup_done
        lea     esi, [edi+entry_code_len-1]
        lea     edi, [esi+2]
        std
        rep     movsb
        cld
        mov     byte ptr [edi-3], 20h
        mov     word ptr [edi-1], 50ADh
        sub     byte ptr [edi+15], 2
        sub     dword ptr [edi+17], 2
        sub     dword ptr [eax+12], 2
entry_setup_done:
	mov	edi, eax
	mov	eax, [edi+16]
	mov	ecx, 100
	mul	ecx
	div	[insize]
	aam
	xchg	al, ah
	add	ax, '00'
	mov	[ratio], ax
	mov	esi, offset done_str
	push	done_len
	pop	ecx
	call	write_string
; save output file
	mov	esi, offset outname
	call	get_full_name
	mov	ebx, offset fn70block
	mov	byte ptr [ebx], 2
	mov	eax, [outfilebest]
	mov	ecx, [eax+16]
	mov	[ebx+12], ecx
	mov	[ebx+16], eax
	push	70
	pop	eax
	int	40h
	test	eax, eax
	jz	short @f
outerr:
	mov	esi, offset outfileerr_str
	push	outfileerr_len
	pop	ecx
	jmp	write_string
@@:
	ret

set_outfile:
	mov	eax, [outfilebest]
	xor	eax, [outfile1]
	xor	eax, [outfile2]
	mov	[outfile], eax
	ret

pack_calltrick_fail:
	xor	eax, eax
	mov	[ctn], 0
	ret
preprocess_calltrick:
; input preprocessing
	xor	eax, eax
	mov	edi, offset ct1
	mov	ecx, 256/4
	push	edi
	rep	stosd
	pop	edi
	mov	ecx, [insize]
	mov	esi, [infile]
	xchg	eax, edx
	mov	ebx, [inbuftmp]
input_pre:
	lodsb
	sub	al, 0E8h
	cmp	al, 1
	ja	short input_pre_cont
	cmp	ecx, 5
	jb	short input_pre_done
	lodsd
	add	eax, esi
	sub	eax, [infile]
	cmp	eax, [insize]
	jae	short xxx
	cmp	eax, 1000000h
	jae	short xxx
	sub	ecx, 4
; bswap is not supported on i386
	xchg	al, ah
	ror	eax, 16
	xchg	al, ah
	mov	[esi-4], eax
	inc	edx
	mov	[ebx], esi
	add	ebx, 4
	jmp	short input_pre_cont
xxx:	sub	esi, 4
	movzx	eax, byte ptr [esi]
	mov	byte ptr [eax+edi], 1
input_pre_cont:
	loop	input_pre
input_pre_done:
	mov	[ctn], edx
	xor	eax, eax
	mov	ecx, 256
	repnz	scasb
	jnz	pack_calltrick_fail
	not	cl
	mov	[cti], cl
@@:
	cmp	ebx, [inbuftmp]
	jz	@f
	sub	ebx, 4
	mov	eax, [ebx]
	mov	[eax-4], cl
	jmp	@b
@@:
	mov	al, 1
	ret

pack_aplib:
	push	0
	push	[workmem]
	mov	eax, [insize]
	sub	eax, [indelta]
	push	eax
	mov	eax, [outfile]
	add	eax, 24h
	push	eax
	mov	eax, [infile]
	add	eax, [indelta]
	push	eax
	call	_aP_pack
	add	esp, 20
	ret
pack_lzma:
	push	[workmem]
	mov	eax, [insize]
	sub	eax, [indelta]
	push	eax
	mov	eax, [outfile]
	add	eax, 24h - 5
	push	eax
	mov	eax, [infile]
	add	eax, [indelta]
	push	eax
	call	lzma_compress
	mov	ecx, [outfile]
	mov	ecx, [ecx+20h]
	xchg	cl, ch
	ror	ecx, 16
	xchg	cl, ch
	mov	dword ptr [loader_lzma + 5], ecx
	sub	eax, 5
	ret

preprocess_calltrick2:
; restore input
	mov	esi, [infile]
	mov	ecx, [ctn]
	jecxz	pc2l2
pc2l1:
	lodsb
	sub	al, 0E8h
	cmp	al, 1
	ja	short pc2l1
	mov	al, [cti]
	cmp	[esi], al
	jnz	short pc2l1
	lodsd
	shr	ax, 8
	ror	eax, 16
	xchg	al, ah
	sub	eax, esi
	add	eax, [infile]
	mov	[esi-4], eax
	loop	pc2l1
pc2l2:
; input preprocessing
	mov	edi, offset ct1
	xor	eax, eax
	push	edi
	mov	ecx, 256/4
	rep	stosd
	pop	edi
	mov	ecx, [insize]
	mov	esi, [infile]
	mov	ebx, [inbuftmp]
	xchg	eax, edx
input_pre2:
	lodsb
@@:
	cmp	al, 0Fh
	jnz	short ip1
	dec	ecx
	jz	short input_pre_done2
	lodsb
	cmp	al, 80h
	jb	short @b
	cmp	al, 90h
	jb	short @f
ip1:
	sub	al, 0E8h
	cmp	al, 1
	ja	short input_pre_cont2
@@:
	cmp	ecx, 5
	jb	short input_pre_done2
	lodsd
	add	eax, esi
	sub	eax, [infile]
	cmp	eax, [insize]
	jae	short xxx2
	cmp	eax, 1000000h
	jae	short xxx2
	sub	ecx, 4
	xchg	al, ah
	rol	eax, 16
	xchg	al, ah
	mov	[esi-4], eax
	inc	edx
	mov	[ebx], esi
	add	ebx, 4
	jmp	short input_pre_cont2
xxx2:	sub	esi, 4
	movzx	eax, byte ptr [esi]
	mov	byte ptr [eax+edi], 1
input_pre_cont2:
	loop	input_pre2
input_pre_done2:
	mov	[ctn], edx
	xor	eax, eax
	mov	ecx, 256
	repnz	scasb
	jnz	pack_calltrick_fail
	not	cl
	mov	[cti], cl
@@:
	cmp	ebx, [inbuftmp]
	jz	short @f
	sub	ebx, 4
	mov	eax, [ebx]
	mov	[eax-4], cl
	jmp	short @b
@@:
	mov	al, 1
	ret

get_full_name:
	push	esi
	mov	esi, offset path
	mov	ecx, [esi-4]
	mov	edi, offset fullname
	rep	movsb
	mov	al, '/'
	cmp	byte ptr [edi-1], al
	jz	short @f
	stosb
@@:	pop	esi
	cmp	byte ptr [esi], al
	jnz	short @f
	mov	edi, offset fullname
@@:	mov	ecx, [esi-4]
	rep	movsb
	xor	eax, eax
	stosb
	ret

redraw_bForceMemInc:
	cmp	[bForceMemInc], 0
	jnz	short draw_bForceMemInc_true
	push	8
	pop	eax
	mov	edx, 80000006h
	int	40h
	mov	al, 8
	mov	esi, [color_table+36]
	mov	ebx, 8000Ah
	mov	ecx, [skinheight]
	shl	ecx, 16
	add	ecx, 0Ah+280000h
	push	6
	pop	edx
	int	40h
	ret

draw_bForceMemInc_true:
	push	38
	pop	eax
	mov	ebx, 0B0010h
	mov	ecx, [skinheight]
	shl	ecx, 16
	mov	cx, word ptr [skinheight]
	add	ecx, 2A002Fh
	mov	edx, [color_table+28]
	int	40h
	rol	ecx, 16
	int	40h
	ret

wsret:	ret
write_string:
	cmp	[bQuiet], 0
	jnz	short wsret
; in: esi=pointer, ecx=length
	mov	edx, [message_cur_pos]
x1:
	lea	edi, [message_mem+edx]
do_write_char:
	lodsb
	cmp	al, 10
	jz	short newline
	stosb
	inc	edx
	loop	do_write_char
	jmp	short x2
newline:
	xor	eax, eax
	stosb
	xchg	eax, edx
	push	ecx
	push	eax
	mov	ecx, 80
	div	ecx
	pop	eax
	xchg	eax, edx
	sub	edx, eax
	add	edx, ecx
	pop	ecx
	loop	x1
x2:	mov	[message_cur_pos], edx
; update window
	push	13
	pop	eax
	mov	ebx, 901A1h
	mov	ecx, [skinheight]
	shl	ecx, 16
	add	ecx, 3700DEh
	mov	edx, [color_table+20]
	int	40h
draw_messages:
	mov	ebx, [skinheight]
	add	ebx, 3Ch+12*10000h
	mov	edi, offset message_mem
@@:	push	edi
	xor	eax, eax
	push	80
	pop	ecx
	repnz	scasb
	sub	ecx, 79
	neg	ecx
	mov	esi, ecx
	mov	al, 4
	pop	edi
	mov	edx, edi
	mov	ecx, [color_table+32]
	int	40h
	add	ebx, 10
	add	edi, 80
	cmp	edi, offset message_cur_pos
	jb	short @b
	ret

draw_window:
; start redraw
	push	12
	pop	eax
	xor	ebx, ebx
	inc	ebx
	int	40h
	mov	edi, [skinheight]
; define window
	xor	eax, eax
	mov	ebx, 6401B3h
	mov	ecx, 64011Eh
	add	ecx, edi
	mov	edx, [color_table+20]
	add	edx, 03000000h
	int	40h
; caption
	mov	ebx, 80008h
	mov	al, 4
	mov	ecx, [color_table+16]
	mov	edx, offset caption_str
	push	caption_len
	pop	esi
	int	40h
; lines - horizontal
	mov	edx, [color_table+36]
	mov	ebx, 80160h
	mov	ecx, edi
	shl	ecx, 16
	or	ecx, edi
	add	ecx, 20002h
	mov	al, 38
	int	40h
	add	ecx, 0C000Ch
	int	40h
	add	ecx, 0C000Ch
	int	40h
	add	ecx, 0C000Ch
	int	40h
; lines - vertical
	mov	ebx, 80008h
	sub	ecx, 240000h
	int	40h
	add	ebx, 340034h
	int	40h
	add	ebx, 1240124h
	int	40h
; draw frame for messages data
	push	ecx
	mov	ebx, 801AAh
	add	ecx, 340010h
	int	40h
	add	ecx, 0E0h*10001h
	int	40h
	mov	ebx, 80008h
	sub	cx, 0E0h
	int	40h
	mov	ebx, 1AA01AAh
	int	40h
	pop	ecx
; define start button
	mov	al, 8
	mov	cx, 24h
	mov	ebx, 1620048h
	push	2
	pop	edx
	mov	esi, [color_table+36]
	int	40h
; bForceMemInc button
	mov	ebx, 8000Ah
	add	ecx, -24h+0Ah+260000h
	push	ecx
	mov	dl, 6
	int	40h
	push	eax
	cmp	[bForceMemInc], 0
	jz	short @f
	call	draw_bForceMemInc_true
@@:
	push	esi
	lea	ebx, [edi+2Bh+180000h]
	mov	ecx, [color_table+32]
	mov	edx, offset bForceMemIncButton_str
	mov	esi, bForceMemIncButton_len
	mov	al, 4
	int	40h
	pop	esi
	pop	eax
	pop	ecx
; question button
	push	esi
	mov	ebx, 1A10009h
	push	7
	pop	edx
	int	40h
	mov	al, 4
	mov	edx, offset aQuestion
	push	1
	pop	esi
	shr	ecx, 16
	lea	ebx, [ecx+1A40002h]
	mov	ecx, [color_table+28]
	int	40h
	mov	al, 8
	pop	esi
; define settings buttons
	mov	ebx, 90032h
	lea	ecx, [edi+2]
	shl	ecx, 16
	mov	cx, 0Bh
	push	3
	pop	edx
@@:
	int	40h
	add	ecx, 0C0000h
	inc	edx
	cmp	edx, 5
	jbe	@b
; text on settings buttons
	lea	ebx, [edi+5+0C0000h]
	mov	al, 4
	mov	ecx, [color_table+28]
	push	offset buttons1names
	pop	edx
	push	8
	pop	esi
@@:
	int	40h
	add	edx, esi
	add	ebx, 0Ch
	cmp	byte ptr [edx-6], ' '
	jnz	@b
; text on start button
	lea	ebx, [edi+10h+1780000h]
	push	offset aStart
	pop	edx
	push	aStart_len
	pop	esi
	int	40h
; infile, outfile, path strings
	mov	edx, offset inname
	lea	ebx, [edi+400005h]
editdraw:
	mov	esi, [edx-4]
	mov	al, 4
	mov	ecx, [color_table+32]
	int	40h
	cmp	edx, [curedit]
	jnz	short cont
	mov	al, 1
	push	ebx
	push	edx
	movzx	ecx, bx
	shr	ebx, 16
	lea	edx, [esi*2]
	lea	edx, [edx+edx*2]
	lea	ebx, [ebx+edx+2]
	add	ecx, 4
	xor	edx, edx
@@:
	cmp	esi, 48
	jz	@f
	int	40h
	add	ebx, 6
	inc	esi
	jmp	@b
@@:
	pop	edx
	pop	ebx
cont:
	add	edx, 52
	add	ebx, 0Ch
	cmp	edx, offset path+52
	jb	editdraw
; draw messages
	call	draw_messages
; end redraw
	push	12
	pop	eax
	push	2
	pop	ebx
	int	40h
	ret
aQuestion db '?'

copy_name:
	lea	edx, [edi+48]
@@:	lodsb
	cmp	al, ' '
	jbe	short copy_name_done
	stosb
	cmp	edi, edx
	jb	short @b
@@:	lodsb
	cmp	al, ' '
	ja	short @b
copy_name_done:
	dec	esi
	sub	edx, 48
	sub	edi, edx
	mov	[edx-4], edi

skip_spaces:
	lodsb
	cmp	al, 0
	jz	short @f
	cmp	al, ' '
	jbe	short skip_spaces
@@:	dec	esi
	ret

clear_edit_points:
; clear edit points (if is)
	mov	esi, [curedit]
	test	esi, esi
	jz	short cleared_edit_points
	push	eax
	mov	al, 13
	mov	ebx, [esi-4]
	imul	ebx, 6
	mov	edi, ebx
	add	ebx, 40h
	shl	ebx, 16
	add	ebx, 48*6
	sub	bx, di
	mov	ecx, [curedit_y]
	shl	ecx, 16
	mov     cl, 9
	mov	edx, [color_table+20]
	int	40h
	pop	eax
cleared_edit_points:
	ret

	end	_start
